package com.fossgalaxy.games.ggj2017;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.geom.Area;
import java.util.Collection;

import org.codetome.hexameter.core.api.CubeCoordinate;
import org.codetome.hexameter.core.api.Hexagon;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.HexagonTile;
import com.fossgalaxy.games.rts.order.MoveOrder;
import com.fossgalaxy.games.rts.order.Order;
import com.fossgalaxy.games.rts.ui.GameAction;
import com.fossgalaxy.games.rts.ui.GameView;

public class MoveAction implements GameAction {
	private final Color HINT_MOVE_COLOUR = new Color(161, 191, 253, 50);
	private final Stroke HINT_STROKE = new BasicStroke(2f);
	
	@Override
	public void renderHints(Graphics2D g, GameState s, Entity actor) {
		if (actor == null) {
			return;
		}
		
		Collection<Hexagon<HexagonTile>> range = s.getRange(actor.getPos(), actor.getType().getMovement());
		System.out.println(range);
		
		Area area = new Area();
		
		range.forEach(h -> {
	        Entity e = s.getEntityAt(h.getCubeCoordinate());
	        if (e != null) {
	        	return;
	        }
	        
		    Shape hexShape = GameView.hex2shape.apply(h);
	        area.add(new Area(hexShape));
	        
	        g.setColor(HINT_MOVE_COLOUR);
	        g.fill(hexShape);
		});
		
        g.setColor(Color.BLUE);
        g.setStroke(HINT_STROKE);
        g.draw(area);
		
	}

	@Override
	public Order generateOrder(CubeCoordinate co, GameState s) {
		return new MoveOrder(co);
	}

	@Override
	public boolean isPossible(Entity entity) {
		return entity.getType().getMovement() >= 1;
	}
}
